Unit GSR1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSU1R_p;

procedure GSR1R(var ISEED :Integer; N :Integer; IOPT :Integer;
                var Z :Array of Real);

implementation

procedure GSR1R(var ISEED :Integer; N :Integer; IOPT :Integer;
                var Z :Array of Real);
var
J,K1,K :Integer;
S2 :Real;
R :Array [0..3] of Real;
U :Array [0..3] of Real;
S :Array [0..3] of Real;
label
_1,_2,_3,_4;
begin
for J:=1 to N do
 begin
  K := 1;
  goto _2;
_1:
  K := 3;
_2:
  GSU1R(ISEED,2,R[K-1]);
  K1 := K+1;
  U[K-1] := R[K-1]+R[K-1]-1.0;
  U[K1-1] := R[K1-1]+R[K1-1]-1.0;
  S[K-1] := U[K-1]*U[K-1]+U[K1-1]*U[K1-1];
  if ( S[K-1] >= 1.0 ) 
   then goto _2;
  if ( K = 3 ) 
   then goto _3;
  if ( IOPT = 4 ) 
   then goto _1;
  S2 := Sqrt(1.0-S[0]);
  Z[(J-1)+0*N] := (U[0]+U[0])*S2;
  Z[(J-1)+1*N] := (U[1]+U[1])*S2;
  Z[(J-1)+2*N] := 1.0-S[0]-S[0];
  goto _4;
_3:
  Z[(J-1)+0*N] := U[0];
  Z[(J-1)+1*N] := U[1];
  S2 := Sqrt((1.0-S[0])/S[2]);
  Z[(J-1)+2*N] := U[2]*S2;
  Z[(J-1)+3*N] := U[3]*S2;
_4:
 end;
end;

end.
